#include <iostream>
#include <string>
using namespace std;

#include "testdel.hh"

TestWidget::TestWidget(QWidget* parent, const char* name)
    : QWidget(parent, name)
{
    QPushButton *delButton = new QPushButton("delButton", this, "delbutton");
    delButton->resize(100, 30);

    delButton->show();

    QObject::connect(delButton, SIGNAL(clicked()),
                     this, SLOT(slotClicked()));
}

void TestWidget::slotClicked()
{
    cout << "Clicked button" << endl;
    this->sigDelWidget();
}

TestWindow::TestWindow(QWidget* parent, const char* name)
    : QMainWindow(parent, name)
{
    w = new TestWidget(this);

    w->show();

    QObject::connect(w, SIGNAL(sigDelWidget()),
                     this, SLOT(slotKillTestWidget()));
}

void TestWindow::slotKillTestWidget()
{
    cout << "Deleting test widget" << endl;

    // This causes an illegal instruction.
    removeChild(w);
    delete w;

    // This seems to work ok though
    //w->deleteLater();
    w = 0;
}
